" 
"  TOPPERS Software
"      Toyohashi Open Platform for Embedded Real-Time Systems
" 
"  Copyright (C) 2011 by TAKUYA
"              Embedded and Real-Time Systems Laboratory
"              Graduate School of Information Science, Nagoya Univ., JAPAN
" 
"  上記著作権者は，以下の (1)〜(4) の条件を満たす場合に限り，本ソフトウェ
"  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改変・
"  再配布（以下，利用と呼ぶ）することを無償で許諾する．
"  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作権
"      表示，この利用条件および下記の無保証規定が，そのままの形でソース
"      コード中に含まれていること．
"  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使用
"      できる形で再配布する場合には，再配布に伴うドキュメント（利用者マ
"      ニュアルなど）に，上記の著作権表示，この利用条件および下記の無保
"      証規定を掲載すること．
"  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使用
"      できない形で再配布する場合には，次のいずれかの条件を満たすこと．
"    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著作
"        権表示，この利用条件および下記の無保証規定を掲載すること．
"    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに報
"        告すること．
"  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損害
"      からも，上記著作権者およびTOPPERSプロジェクトを免責すること．また，
"      本ソフトウェアのユーザまたはエンドユーザからのいかなる理由に基づ
"      く請求からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
" 
"  本ソフトウェアは，無保証で提供されているものである．上記著作権者およ
"  びTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的に対す
"  る適合性も含めて，いかなる保証も行わない．また，本ソフトウェアの利用
"  により直接的または間接的に生じたいかなる損害に関しても，その責任を負
"  わない．
"
"
" Vim syntax file
" Language:	tf (Template File for TOPPERS)
" Maintainer:	TAKUYA
" Last Change:	2011 Jun 28

" Quit when a (custom) syntax file was already loaded
if exists("b:current_syntax")
  finish
endif

" synでキーワード，パターン，範囲の先頭と終わりを登録する
" msはパターンマッチの始まり，meはパターンマッチの終わり
" hsはハイライトの始まり，heはハイライトの終わり

" 括弧
syn match   tfParen "[()]"

syn region  tfSpecialRegion start="\$" end="\$" contains=ALL

" コメント
syn region  tfComment start="^\$[ \t]" end="$" 

" 文字列
syn region  tfString start=+"+ skip=+\\"+ end=+"+
syn region  tfString start=+'+ skip=+\\'+ end=+'+

" 定数
syn match   tfConstant "\$NL\$"
syn match   tfConstant "\$SPC\$"
syn match   tfConstant "\$TAB\$"
syn match   tfConstant "\$ARGC\$"
syn match   tfConstant "\$ARGV\$"
syn match   tfConstant "\$RESULT\$"

" 制御文
syn keyword tfMacro contained FILE
syn keyword tfMacro contained FUNCTION
syn keyword tfMacro contained INCLUDE
syn keyword tfMacro contained IF
syn keyword tfMacro contained FOREACH
syn keyword tfMacro contained JOINEACH
syn keyword tfMacro contained ERROR
syn keyword tfMacro contained WORNING
syn match   tfMacro +\$END\$+hs=s+1,he=e-1
syn match   tfMacro +\$ELSE\$+hs=s+1,he=e-1

" 関数
syn match   tfLabel contained +LENGTH(+me=e-1
syn match   tfLabel contained +EQ(+me=e-1
syn match   tfLabel contained +ALT(+me=e-1
syn match   tfLabel contained +SORT(+me=e-1
syn match   tfLabel contained +ENVIRON(+me=e-1
syn match   tfLabel contained +VALUE(+me=e-1
syn match   tfLabel contained +CONCAT(+me=e-1
syn match   tfLabel contained +APPEND(+me=e-1
syn match   tfLabel contained +AT(+me=e-1
syn match   tfLabel contained +_(+me=e-1
syn match   tfLabel contained +FORMAT(+me=e-1
syn match   tfLabel contained +FIND(+me=e-1
syn match   tfLabel contained +RANGE(+me=e-1
syn match   tfLabel contained +SYMBOL(+me=e-1
syn match   tfLabel contained +PEEK(+me=e-1
syn match   tfLabel contained +DUMP(+me=e-1
syn match   tfLabel contained +TRACE(+me=e-1
syn match   tfLabel contained +NOOP(+me=e-1
syn match   tfLabel contained +BCOPY(+me=e-1
syn match   tfLabel contained +ESCSTR(+me=e-1
syn match   tfLabel contained +UNESCSTR(+me=e-1
syn match   tfLabel contained +CALL(+me=e-1
syn match   tfLabel contained +LSORT(+me=e-1

"syn match   tfDollar contained "\$"

"syn cluster tfSpecialChar contains=tfParen,tfDollar
syn cluster tfSpecialChar contains=tfParen

hi def link tfComment Comment
hi def link tfConstant Constant
hi def link tfMacro Macro 
hi def link tfString String
hi def link tfLabel Label
hi def link tfParen SpecialChar
hi def link @tfSpecialChar SpecialChar

let b:current_syntax = "tf"

